#!/usr/bin/perl -w

# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

use strict;
use CGI qw(:cgi);
use Net::DNS;
use Time::Local;

$| = 1;
my $version = "0.5";
my $url = "";
my $query = "";
my $answer = "";
my $redir = "";
my $resolve = new Net::DNS::Resolver;

while(<STDIN>) {
  # We need the Host: Header to determine where the user really
  # wants to go...
  if (/^Host: (.*)\r\n$/) {
    $url = $1;
    if (length($url) > 255) {
      # DNS names cannot be longer than 255 bytes
      # If we receive a string longer than that we just cut it
      $url = substr($url, 0, 255);
    }
    print STDERR $ENV{"TCPREMOTEIP"}." requested $url\n";
    # Let's get the TXT record from DNS
    $query = $resolve->query($url, 'TXT');
    if ($query) {
      foreach $answer ($query->answer) {
        $redir = $answer->txtdata;
        print STDERR "$url redirects to $redir\n";
      }
    }
    else {
      # If we do not find a TXT record we use the default
      $redir = $ARGV[0];
    }
    if ($redir) {
      print STDERR "Sending reply to ".$ENV{"TCPREMOTEIP"}."\n";
      print "HTTP/1.1 301 MOVED\r\n";
      print "Date: ".localtime()."\r\n";
      print "Server: dnsredir.pl $version\r\n";
      print "Connection: close\r\n";
      print "Pragma: no-cache\r\n";
      print "Expires: 0\r\n";
      print "Location: $redir\r\n";
      print "Content-Type: text/plain\r\n";
      print "\r\n";
    }
  }
}  
close(STDIN);

exit(0);
